{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit Lpropfrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, Gauges;

Type
  TPropForm = class(TForm)
    LayerListBox: TListBox;
    OKBtn: TButton;
    ApplyBtn: TButton;
    LayerUpBtn: TSpeedButton;
    LayerDownBtn: TSpeedButton;
    LineCB: TComboBox;
    OutlineCkBox: TCheckBox;
    DeleteLayerBtn: TSpeedButton;
    ColorDialog1: TColorDialog;
    ShapeColorPanel: TPanel;
    OutlineColorPanel: TPanel;
    HelpBitBtn: TBitBtn;
    Label2: TLabel;
    LabelRotateEdit: TEdit;
    LabeledTBar: TTrackBar;
    LabelFontBtn: TButton;
    LabelColorPanel: TPanel;
    LabelBackgrounded: TCheckBox;
    LabeledCB: TCheckBox;
    LabelFieldCBox: TComboBox;
    VisibleCB: TCheckBox;
    LineWidthEdit: TEdit;
    UpDown1: TUpDown;
    ShapeCB: TComboBox;
    Bevel1: TBevel;
    ResetBtn: TButton;
    EditableCB: TCheckBox;
    FontDialog1: TFontDialog;
    LabelasSelectedBtn: TButton;
    ProgressBar1: TProgressBar;
    FontLabel: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
procedure Init;
procedure SetActive(isActive:Boolean);
    procedure ApplyBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure LayerListBoxClick(Sender: TObject);
    procedure OutlineColorPanelClick(Sender: TObject);
    procedure LayerUpBtnClick(Sender: TObject);
    procedure LayerDownBtnClick(Sender: TObject);
    procedure DeleteLayerBtnClick(Sender: TObject);
    procedure OutlineCkBoxClick(Sender: TObject);
procedure SetupStyleCombo(index: integer);
    procedure LineCBChange(Sender: TObject);

    procedure HelpBitBtnClick(Sender: TObject);
    procedure ShapeColorPanelClick(Sender: TObject);
    procedure ShapeCBChange(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure LabelBackgroundedClick(Sender: TObject);
    procedure LabelColorPanelClick(Sender: TObject);
    procedure VisibleCBClick(Sender: TObject);
    procedure LabelFieldCBoxChange(Sender: TObject);
    procedure LabeledTBarChange(Sender: TObject);
    procedure EditableCBClick(Sender: TObject);
    procedure LabelFontBtnClick(Sender: TObject);
    procedure LineWidthEditChange(Sender: TObject);
    procedure LabelasSelectedBtnClick(Sender: TObject);
  private

  public
    { Public declarations }
  end;

var
  PropForm: TPropForm;
(*  PropCurrentLayer,{selected from LayerComboBox or LayerCount when loaded}
  PropCurrentObj, {selected when searching else 0}
  PropCurrentObjPart,
  PropCurrentObjPoint,
  PropCurrentField {selected from FieldComboBox}
  :Integer;      *)
implementation

uses Llabelfrm, LoGlobals, LoeditFrm, AllShapeLoaderFrm;

{$R *.DFM}

procedure TPropForm.FormClose(Sender: TObject;
               var Action: TCloseAction);
begin
  propfrmY := PropForm.top;
  propfrmX := PropForm.left;
end;

procedure TPropForm.FormCreate(Sender: TObject);
begin
  top := propfrmY;
  left := propfrmX;
end;

procedure TPropForm.HelpBitBtnClick(Sender: TObject);
begin
  Application.HelpContext(12000);
end;

procedure TPropForm.FormShow(Sender: TObject);
begin
  Init;
end;

procedure TPropForm.Init;
var
  II,i: integer;
begin
  LayerListBox.Items.Clear;
  for i := 0 to LayersLoaded - 1 do
  begin
    LayerListBox.Items.Add(LayA[i+1].Filename);
  end;
  LayerListBox.ItemIndex := 0;
  LayerUpBtn.Enabled := LayerListBox.Items.Count > 1;
  LayerDownBtn.Enabled := LayerListBox.Items.Count > 1;

  if LayerListBox.Items.Count = 0 then
  begin
    ShapeColorPanel.Enabled := False;
    OutlineColorPanel.Enabled := False;
    LabelColorPanel.Enabled := False;
    LabelFontBtn.Enabled := False;
    DeleteLayerBtn.Enabled := False;
    OutlineCkBox.Enabled := False;
  end;

  if LayA[1].ShpType = 3 then //moFillSymbol
  begin
    OutlineCkBox.Enabled := False;
    ShapeColorPanel.Enabled := False;
    OutlineColorPanel.Enabled := True;
  end
  else
  begin
    OutlineCkBox.Enabled := True;
    OutlineColorPanel.Enabled := True;
    ShapeColorPanel.Enabled := True;
    OutlineCkBox.Checked := Mapa[1].isSymLayerOutlined;
  end;
  SetupStyleCombo(LayA[1].ShpType);
  ShapeColorPanel.color :=Mapa[1].SymLayerBrushColor;
  OutlineColorPanel.color := Mapa[1].SymLayerLineColor;

  If Mapa[1].SymLayerLabeled>0 then
  LabeledCB.Checked :=True else
  LabeledCB.Checked :=False;
  LabelFontBtn.Font:=Mapa[1].SymFont;
  FontLabel.Font :=Mapa[1].SymFont;
  LabelColorPanel.color := Mapa[1].SymLayerLabelBackColor;
  LabelRotateEdit.Text := IntToStr((Mapa[1].labelAngle));
  LabeledTBar.Position:=Mapa[1].labelAngle;
  LabelBackgrounded.Checked:=Mapa[1].isSymLayerLabelColored;
  LabelFieldCBox.Items.Clear;
  for ii := 0 to LayA[1].AttributesN-1  do
  begin
    LabelFieldCBox.Items.Add(LayA[1].AttType[ii].Displayname);
  end;
  LabelFieldCBox.ItemIndex := Mapa[1].Field;
end;

procedure TPropForm.LabelFieldCBoxChange(Sender: TObject);
begin
  Mapa[LayerListBox.ItemIndex+1].Field:=LabelFieldCBox.ItemIndex+1;
end;



procedure TPropForm.ApplyBtnClick(Sender: TObject);
begin
  Mapa[LayerListBox.ItemIndex+1].SymLayerSymboled:=1;
  VoEditForm.DVDORedraw;
end;

procedure TPropForm.ResetBtnClick(Sender: TObject);
var
  II,i: integer;
begin
{Reset ALL Layers to Defaults}
  For II:= 1 to LayersLoaded do
  begin
    Mapa[II].isSymLayerEditable := True;
    ShapeLoaderForm.SetDisplayStyle(II);
    Mapa[II].SymLayerBeginSize:=5;
    Mapa[II].SymLayerEndSize:=25;
    Mapa[II].SymLayerClasses:=5;
    Mapa[II].SymLayerSymboled:=1;
    Mapa[II].SymLayerLabeled:=0;
    Mapa[II].SymLayerStartColor:=clLime;
    Mapa[II].SymLayerFinishColor:=clGreen;
    Mapa[II].isSymLayerOutlined:=True;
    Mapa[II].SymLayerLabelBackColor:=clWhite;
    Mapa[II].isSymLayerLabelColored:=True;
    Mapa[II].SymFont:=LineWidthEdit.Font;
    Mapa[II].labelHeight:=0;
    Mapa[II].labelAngle:=0;
    Mapa[II].Field:=0;
    SetLength(Mapa[II].SymLayerClassBreaks,6);
    For I:= 0 to 5 do
    Mapa[II].SymLayerClassBreaks[i]:=I;
  End;
Init;
end;

procedure TPropForm.OKBtnClick(Sender: TObject);
begin
{  ApplyBtnClick(self); }
  VoEditForm.LayerComboUpdate(LayerListBox.ItemIndex+1);
  VoEditForm.LayerComboBoxChange(Sender);
  ModalResult := mrOK;
end;


procedure TPropForm.LayerListBoxClick(Sender: TObject);
var
  II,  i: integer;
begin
  i := LayerListBox.ItemIndex;
  if i < 0 then Exit;
  LayerUpBtn.Enabled := i > 0;
  LayerDownBtn.Enabled := i < LayerListBox.Items.Count - 1;
inc(i);
  If (Mapa[i].SymLayerSymboled >0)then
  Begin
  SetActive(True);
  VisibleCB.Checked := True;
  if LayA[i].ShpType = 3 then //moFillSymbol
  begin
    OutlineCkBox.Enabled := False;
    ShapeColorPanel.Enabled := False;
    OutlineColorPanel.Enabled := True;
  end
  else
  begin
    OutlineColorPanel.Enabled := True;
    ShapeColorPanel.Enabled := True;
    OutlineCkBox.Enabled := True;
    OutlineCkBox.Checked := Mapa[i].isSymLayerOutlined;
    SetupStyleCombo(3);{Lines too}
  end;

  SetupStyleCombo(LayA[i].ShpType);
  EditableCB.Checked:=Mapa[i].isSymLayerEditable;
  ShapeColorPanel.color :=Mapa[i].SymLayerBrushColor;
  OutlineColorPanel.color := Mapa[i].SymLayerLineColor;
  LineWidthEdit.Text := IntToStr(Mapa[i].SymLayerLineWidth);
  End else SetActive(False);

  If Mapa[i].SymLayerLabeled>0 then
     LabeledCB.Checked :=True else
     LabeledCB.Checked:=False;
  LabelRotateEdit.Text := IntToStr((Mapa[i].labelAngle));
  LabeledTBar.Position:=Mapa[i].labelAngle;
  LabelBackgrounded.Checked:=Mapa[i].isSymLayerLabelColored;
{  LabelFontBtn.Font:=Mapa[i].SymFont;}
  FontLabel.Font:=Mapa[i].SymFont;
  LabelColorPanel.color := Mapa[i].SymLayerLabelBackColor;
  LabelFieldCBox.Items.Clear;
  for ii := 0 to LayA[i].AttributesN-1  do
  begin
    LabelFieldCBox.Items.Add(LayA[i].AttType[ii].Displayname);
  end;
  LabelFieldCBox.ItemIndex := Mapa[i].Field;
end;


procedure TPropForm.OutlineColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:= OutlineColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    MapA[LayerListBox.ItemIndex+1].SymLayerLineColor :=
      ColorDialog1.Color;
    OutlineColorPanel.Color := ColorDialog1.Color;
  Mapa[LayerListBox.ItemIndex+1].SymLayerSymboled:=1;    
  end;
end;

procedure TPropForm.LineWidthEditChange(Sender: TObject);
begin
   If LineWidthEdit.Modified then
   MapA[LayerListBox.ItemIndex+1].SymLayerLineWidth :=
   StrtoInt(LineWidthEdit.Text);
end;

procedure TPropForm.LayerUpBtnClick(Sender: TObject);
var
  TempDupe,i: integer;
begin
  i := LayerListBox.ItemIndex;
TempDupe:=LayersControlArray[i-1];
LayersControlArray[i-1]:=LayersControlArray[i];
LayersControlArray[i]:=TempDupe;

  LayerListBox.Items.Exchange(i, i - 1);
  LayerListBox.ItemIndex := i - 1;
  LayerUpBtn.Enabled := i - 1 > 0;
  LayerDownBtn.Enabled := i - 1 < LayerListBox.Items.Count - 1;
{  PropCurrentLayer:=LayerListBox.ItemIndex+1;}
end;

procedure TPropForm.LayerDownBtnClick(Sender: TObject);
var
  TempDupe,i: integer;
begin
  i := LayerListBox.ItemIndex;
TempDupe:=LayersControlArray[i+1];
LayersControlArray[i+1]:=LayersControlArray[i];
LayersControlArray[i]:=TempDupe;
{  lyrs.MoveTo(i, i + 1); the LAYER from the IndexArray}
  LayerListBox.Items.Exchange(i, i + 1);
  LayerListBox.ItemIndex := i + 1;
  LayerUpBtn.Enabled := i + 1 > 0;
  LayerDownBtn.Enabled := i + 1 < LayerListBox.Items.Count - 1;
{  PropCurrentLayer:=LayerListBox.ItemIndex+1;}
end;

procedure TPropForm.DeleteLayerBtnClick(Sender: TObject);
var
  TempDupe,i: integer;
begin
  i := LayerListBox.ItemIndex;
  if i < 0 then Exit;
  If LayersControlArray[i]=PointLayerCreatedAs then
  begin
      PointLayerCreatedAs:=0;
      PointLayerCreated:=False;
      VoEditForm.CreatePointLayer1.Enabled:=True;
      VoEditForm.CreatePoint1.Enabled:=False;
  end;
  If LayersControlArray[i]=AnnoLayerCreatedAs then
  begin
      AnnoLayerCreatedAs:=LayersLoaded;
      AnnoLayerCreated:=False;
      VoEditForm.CreateAnnoLayer1.Enabled:=True;
      VoEditForm.CreateLabelpt1.Enabled:=False;
  end;
  If LayersControlArray[i]=LineLayerCreatedAs then
  begin
      LineLayerCreatedAs:=LayersLoaded;
      LineLayerCreated:=False;
      VoEditForm.CreateLineLayer1.Enabled:=True;
      VoEditForm.CreateLine1.Enabled:=False;
  end;
  If LayersControlArray[i]=PolygonLayerCreatedAs then
  begin
      PolygonLayerCreatedAs:=LayersLoaded;
      PolygonLayerCreated:=False;
      VoEditForm.CreatePolygonLayer1.Enabled:=True;
      VoEditForm.CreatePolygon1.Enabled:=False;
  end;
{  DELETE the LAYER from the IndexArray }
If LayersLoaded=1 then LayersControlArray[0]:=0
else
begin
For TempDupe:=i to LayersLoaded-2 do
LayersControlArray[i]:=LayersControlArray[i+1];
end;
  dec(LayersLoaded);

  LayerListBox.Items.Delete(i);
  LayerListBox.ItemIndex:=0;
If LayersLoaded=0 then
begin
  VoEditForm.ClearAllClick(Sender);
  ModalResult := mrOK;
  Close;
End else
begin
CurrentLayer:=1;
Init;
{never get to do this...
  if LayerListBox.Items.Count = 0 then
  begin
    ShapeColorPanel.Enabled := False;
    OutlineColorPanel.Enabled := False;
    LabelColorPanel.Enabled := False;
    LabelFontBtn.Enabled := False;
    DeleteLayerBtn.Enabled := False;
    OutlineCkBox.Enabled := False;
  end;}
end;
end;

procedure TPropForm.VisibleCBClick(Sender: TObject);
begin
  If (VisibleCB.Checked)
  then
  begin{Active}
    SetActive(True);
    Mapa[LayerListBox.ItemIndex+1].SymLayerSymboled := 1;
  end
  else
  begin
    SetActive(False);
    Mapa[LayerListBox.ItemIndex+1].SymLayerSymboled := 0;
  end;
end;

procedure TPropForm.SetActive(isActive:Boolean);
Begin
    UpDown1.Enabled := isActive;
    ShapeColorPanel.Enabled := isActive;
    OutlineColorPanel.Enabled := isActive;
    OutlineCkBox.Enabled := isActive;
    ShapeCB.Enabled := isActive;
    LineCB.Enabled := isActive;

    LabeledCB.Enabled := isActive;
    LabelFieldCBox.Enabled := isActive;
    LabelFontBtn.Enabled := isActive;
    LabeledTBar.Enabled := isActive;
    LabelBackgrounded.Enabled := isActive;
    LabelColorPanel.Enabled := isActive;
End;

procedure TPropForm.EditableCBClick(Sender: TObject);
begin
  If (EditableCB.Checked)
  then Mapa[LayerListBox.ItemIndex+1].isSymLayerEditable := True
  else Mapa[LayerListBox.ItemIndex+1].isSymLayerEditable := False;
end;

procedure TPropForm.OutlineCkBoxClick(Sender: TObject);
begin
  Mapa[LayerListBox.ItemIndex+1].isSymLayerOutlined :=
  OutlineCkBox.Checked;
If (OutlineCkBox.Checked)
then
begin
  Mapa[LayerListBox.ItemIndex+1].SymLayerLineStyle:=0;
  Mapa[LayerListBox.ItemIndex+1].SymLayerLineColor:=  clBlack;
  OutlineColorPanel.Color:=  clBlack;
end else
begin
  Mapa[LayerListBox.ItemIndex+1].SymLayerLineStyle:=5;
  Mapa[LayerListBox.ItemIndex+1].SymLayerLineColor:=BackgroundColor;
  OutlineColorPanel.Color:=BackgroundColor;
end;
end;

procedure TPropForm.SetupStyleCombo(index: integer);
begin
  if ((index = 1)or(index = 8))  then
  begin
  ShapeCB.Items.Clear;
    with ShapeCB.Items do
    begin
      Add('Square Marker');
      Add('Circle Marker');
      Add('Triangle Marker');
      Add('Dot Marker');
      Add('Dot Circle Marker');
      Add('XBox Marker');
    end;
  end
  else
  begin
    LineCB.Items.Clear;
    with LineCB.Items do
    begin
      Add('Solid Line');
      Add('Dash Line');
      Add('Dot Line');
      Add('Dash-Dot Line');
      Add('Dash-Dot-Dot Line');
    end;
  LineCB.ItemIndex :=
    Mapa[LayerListBox.ItemIndex+1].SymLayerLineStyle;
  ShapeCB.Items.Clear;
    with ShapeCB.Items do
    begin
      Add('Solid Fill');
      Add('Horizontal Fill');
      Add('Vertical Fill');
      Add('Upward Diagonal Fill');
      Add('Downward Diagonal Fill');
      Add('Cross Fill');
      Add('Diagonal Cross Fill');
      Add('Transparent Fill');      
{      Add('Light Gray Fill');
      Add('Gray Fill');
      Add('Dark Gray Fill');}
    end;
  end;
  ShapeCB.ItemIndex :=
    Mapa[LayerListBox.ItemIndex+1].SymLayerStyle;
end;

procedure TPropForm.ShapeCBChange(Sender: TObject);
begin
  Mapa[LayerListBox.ItemIndex+1].SymLayerStyle :=
  ShapeCB.ItemIndex;
end;

procedure TPropForm.LineCBChange(Sender: TObject);
begin
  Mapa[LayerListBox.ItemIndex+1].SymLayerLineStyle :=
  LineCB.ItemIndex;
end;


procedure TPropForm.ShapeColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:= ShapeColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    Mapa[LayerListBox.ItemIndex+1].SymLayerBrushColor
    := ColorDialog1.Color;
    ShapeColorPanel.Color := ColorDialog1.Color;
  end;
end;
(***********************************************************)
(***********************************************************)

procedure TPropForm.LabelBackgroundedClick(Sender: TObject);
begin
  Mapa[LayerListBox.ItemIndex+1].isSymLayerLabelColored :=
  LabelBackgrounded.Checked;
If (LabelBackgrounded.Checked)
then
begin    {Reset}
  Mapa[LayerListBox.ItemIndex+1].SymLayerLabelBackColor:=
      clWhite;
  LabelColorPanel.Color:=  clWhite;
end else
begin    {Transparent ?}
  Mapa[LayerListBox.ItemIndex+1].SymLayerLabelBackColor:=BackgroundColor;
  LabelColorPanel.Color:=BackgroundColor;
end;
end;

procedure TPropForm.LabelColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:= LabelColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    Mapa[LayerListBox.ItemIndex+1].SymLayerLabelBackColor
    := ColorDialog1.Color;
    LabelColorPanel.Color := ColorDialog1.Color;
  end;
end;




procedure TPropForm.LabeledTBarChange(Sender: TObject);
var tempi:Integer;
begin
   tempi:=LabeledTBar.Position;
   Mapa[LayerListBox.ItemIndex+1].labelAngle:=tempi;
   LabelRotateEdit.Text:=IntToStr(tempi);
   Application.ProcessMessages;
end;


procedure TPropForm.LabelFontBtnClick(Sender: TObject);
begin
  FontDialog1.Font:= FontLabel.Font;
  if FontDialog1.Execute then
  begin
    Mapa[LayerListBox.ItemIndex+1].SymFont
    := FontDialog1.Font;
    FontLabel.Font := FontDialog1.Font;
  end;
end;

procedure TPropForm.LabelasSelectedBtnClick(Sender: TObject);
var
  alog {,FontRecord}:LogFont;{ TLogFont;}
{ahFont,}  ahFont : hFont;{THandle;}
{  ahFont : TFont;}
  NumShape,ShapeToDo, ii{,ilfweight}: integer;
{  ilfitalic,ilfunderline,ilfstrikeout:DWORD;  }
{    mylfFaceName: array[0..LF_FACESIZE - 1] of AnsiChar;}
begin
ProgressBar1.Visible:=True;
ProgressBar1.Position:=0;
  ii:=LayerListBox.ItemIndex+1;
  Mapa[ii].SymLayerLabeled:=1;
  LabeledCB.Checked:=True;
  Mapa[ii].labelAngle:= StrtoInt(LabelRotateEdit.Text);
  Mapa[ii].isSymLayerLabelColored:=  LabelBackgrounded.Checked;
  Mapa[ii].SymLayerLabelBackColor:=LabelColorPanel.color;
  Mapa[ii].Field:=LabelFieldCBox.Itemindex;
  Mapa[ii].SymFont:=FontLabel.Font;
  Mapa[ii].labelHeight:=FontLabel.Font.Height;
{     If fsBold in  Mapa[ii].SymFont.Style
     then  ilfweight :=700 else     ilfweight :=300;
     If fsItalic in  Mapa[ii].SymFont.Style
     then  ilfitalic :=1 else     ilfitalic :=0;
     If fsUnderline	 in  Mapa[ii].SymFont.Style
     then  ilfunderline :=1 else    ilfunderline := 0;
     If fsStrikeout in  Mapa[ii].SymFont.Style
     then  ilfstrikeout :=1 else    ilfstrikeout := 0;}

{     setlength(mylfFaceName,length(Mapa[ii].SymFont.Name));}
{mylfFaceName:=Mapa[ii].SymFont.Name;}{'ARIAL';}
{pchar(Mapa[ii].SymFont.Name);}
{  SetTextAlign(c.Handle, TA_BASELINE);}
  GetObject(FontLabel.Font.Handle, SizeOf(alog), @alog);
  alog.lfEscapement:=(Mapa[ii].labelAngle * 10);
{  if (IsNT) then alog.lfOrientation:=-(Mapa[ii].labelAngle * 10);}
  alog.lfQuality:=PROOF_QUALITY;
  ahfont:=CreateFontIndirect(alog);
 (*
  with alog do
  begin
//LOGFONT struct
//you can find all this in win32 help just look under LOGFONT
    lfheight :=Mapa[ii].labelHeight;
    lfFacename := {'MS Sans Serif';}{pchar(Mapa[ii].SymFont.Name);}{mylfFaceName;}'ARIAL';
    lfwidth := abs(lfheight div 2);
    lfEscapement := (Mapa[ii].labelAngle * 10);
    lfOrientation := lfescapement;
    lfweight := ilfweight;
    lfitalic := ilfitalic;
    lfunderline := ilfunderline;
    lfstrikeout := ilfstrikeout;
    lfcharset := ANSI_CHARSET;
    lfoutprecision := out_tt_precis;
    lfclipprecision := clip_default_precis;
    lfquality := PROOF_QUALITY;
    lfpitchandfamily := default_pitch or ff_swiss;
  end;
*)
FontLabel.Font.handle := ahfont;
{Label1.Font.Name:=Mapa[ii].SymFont.Name;  }
(*  ahfont := CreateFont(
Mapa[ii].labelHeight  {0},
abs(Mapa[ii].labelHeight div 2){0},
(Mapa[ii].labelAngle * 10){0},
(Mapa[ii].labelAngle * 10){0},
ilfweight{0},
{  nHeight, nWidth, nEscapement, nOrientaion, fnWeight: Integer;}
{  0,0,0,}
 ilfitalic,ilfunderline,ilfstrikeout,
{  fdwItalic, fdwUnderline, fdwStrikeOut,}
ANSI_CHARSET{0},out_tt_precis{0},
{  fdwCharSet, fdwOutputPrecision,}
clip_default_precis{0},PROOF_QUALITY{0},default_pitch{0},
{  fdwClipPrecision, fdwQuality, fdwPitchAndFamily: DWORD;}
pchar(Mapa[ii].SymFont.Name));
*)
  if Mapa[ii].labelAngle>0 then
  begin
    if ahFont <> 0 then
{    Mapa[ii].SymFont.Assign(TFontDialog(Sender).Font)}
   Mapa[ii].SymFont.handle := ahfont;
   end;

  NumShape:= LayA[ii].ShapeN;
  For ShapeToDo:=1 to NumShape do
  Begin
    ProgressBar1.Position:= Round((ShapeToDo/NumShape)*100);
    Application.ProcessMessages;
    Mapa[ii].LyrSym[ShapeToDo].isSymLabelSet:=False;
    Mapa[ii].LyrSym[ShapeToDo].SymObjlabelFieldstring:=
    LayA[ii].LyrShp[ShapeToDo].AAttributes[Mapa[ii].Field];
  Mapa[ii].LyrSym[ShapeToDo].labelAngle:= Mapa[ii].labelAngle;
  Mapa[ii].LyrSym[ShapeToDo].isSymLabelColored:= Mapa[ii].isSymLayerLabelColored;
  Mapa[ii].LyrSym[ShapeToDo].SymLabelBackColor:=Mapa[ii].SymLayerLabelBackColor;
{  Mapa[ii].LyrSym[ShapeToDo].Field:=Mapa[ii].Field; }
  Mapa[ii].LyrSym[ShapeToDo].SymFont:=Mapa[ii].SymFont;
  Mapa[ii].LyrSym[ShapeToDo].labelHeight:=Mapa[ii].labelHeight;
  End;
ProgressBar1.Visible:=False;
ProgressBar1.Position:=0;
end;
(*
 procedure TLabelObjectsForm.PlaceThisLabel(ThisLabel: Integer);
var
  hFont {,  OldFonti}: THandle;
  OldBkMode: integer;
  alog {,FontRecord}: TLogFont;
{OldFont:TFont; }
begin {OK ... PLACE the text}
  OldBkMode := 0;

{         GetObject(ObjectLabelArray[ThisLabel].LOFont.Handle,
           Sizeof(FontRecord),
           Addr(FontRecord));}
{  FontRecord.lfEscapement:=(ObjectLabelArray[ThisLabel].RotAngle *10);}
{  FontRecord.lfOrientation:=(ObjectLabelArray[ThisLabel].RotAngle *10);}
{  RasterForm.Image1.Canvas.Font.Handle:=CreateFontIndirect(FontRecord);}
{  RasterForm.Image1.Canvas.Font:=}
{  HFont:=CreateFont(-Size, 0, Angle*10, 0, fw_normal,0,0,0,1,4,$10,2,4,PChar(FontName));}
  with alog do
  begin
//LOGFONT struct
//you can find all this in win32 help just look under LOGFONT
    lfheight :=
{      LOTEdit.Font.Size}
      {10}
    round(LOTEdit.Font.Size * LOTEdit.Font.PixelsPerInch / 72)
      ;
    lfFacename := 'ARIAL';
    lfwidth := abs(lfheight div 2);
    lfEscapement := (ObjectLabelArray[ThisLabel].RotAngle * 10);
    lfOrientation := lfescapement;
    lfweight := fw_normal;
    lfitalic := 0;
    lfunderline := 0;
    lfstrikeout := 0;
    lfcharset := ANSI_CHARSET;
    lfoutprecision := out_tt_precis;
    lfclipprecision := clip_default_precis;
    lfquality := PROOF_QUALITY;
    lfpitchandfamily := default_pitch or ff_swiss;
  end;
  hfont := createfontindirect(alog);
  if RotatedCB.Checked then begin
    if hFont <> 0 then
      with GRIPForm.Image1.Canvas do
      begin
        font.handle := hfont;
{      font.Color := clRed;}
{      font.Charset := LOTEdit.Font.Charset;}
        font.Color := LOTEdit.Font.Color;

{      font.height := LOTEdit.Font.Height;
      font.size := LOTEdit.Font.size; }
{      font.name:= LOTEdit.Font.Name;
      font.Pitch := LOTEdit.Font.Pitch;   }

{      font.Style:=LOTEdit.Font.Style;  }
{ ObjectLabelArray[ThisLabel].LOFont.Charset;
      font.Color := ObjectLabelArray[ThisLabel].LOFont.Color;
      font.height := ObjectLabelArray[ThisLabel].LOFont.Height;
      font.name:= ObjectLabelArray[ThisLabel].LOFont.Name;
      font.Pitch := ObjectLabelArray[ThisLabel].LOFont.Pitch;
      font.size := ObjectLabelArray[ThisLabel].LOFont.size;
      font.Style:=ObjectLabelArray[ThisLabel].LOFont.Style;}
      end else DoMessages(26);
  end else
    with GRIPForm.Image1.Canvas do
    begin
{if RasterForm.Image1.Canvas.Font = nil then
RasterForm.Image1.Canvas.Font:=LOTEdit.Font;}
{  OldFont:=RasterForm.Image1.Canvas.Font;}
      GRIPForm.Image1.Canvas.Font :=
        ObjectLabelArray[ThisLabel].LOFont;
    end;
{  OldFonti:=SelectObject(RasterForm.Image1.Canvas.Font.Handle, HFont);}
  if ObjectLabelArray[ThisLabel].TransBack then
    OldBkMode :=
      SetBkMode(GRIPForm.Image1.Canvas.Handle, 0 {TRANSPARENT})
  else SetBkColor(GRIPForm.Image1.Canvas.Handle,
      ObjectLabelArray[ThisLabel].BackColor);


  GRIPForm.Image1.Canvas.TextOut(
    ObjectLabelArray[ThisLabel].X,
    ObjectLabelArray[ThisLabel].Y,
    ObjectLabelArray[ThisLabel].LOText);
{  SelectObject(RasterForm.Image1.Canvas.Font.Handle, OldFonti);
  DeleteObject(HFont);}
{  RasterForm.Image1.Canvas.Font:=OldFont;}
  if ObjectLabelArray[ThisLabel].TransBack then
    SetBkMode(GRIPForm.Image1.Canvas.Handle,
      OldBkMode);
end;
*)
{
  tagLOGFONTA = packed record
    lfHeight: Longint;
    lfWidth: Longint;
    lfEscapement: Longint;
    lfOrientation: Longint;
    lfWeight: Longint;
    lfItalic: Byte;
    lfUnderline: Byte;
    lfStrikeOut: Byte;
    lfCharSet: Byte;
    lfOutPrecision: Byte;
    lfClipPrecision: Byte;
    lfQuality: Byte;
    lfPitchAndFamily: Byte;
    lfFaceName: array[0..LF_FACESIZE - 1] of AnsiChar;
  end;

}
end.
