{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit Lrenderedfrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Lpropfrm,
  DBTables, ExtCtrls, DB, math,
  Buttons;

type
  TRenderFrm = class(TForm)
    ApplyBtn: TButton;
    ColorDialog1: TColorDialog;
    HelpBtn: TBitBtn;
    ClassListBox2: TListBox;
    ValueSetBtn: TSpeedButton;
    ListBox1: TListBox;
    ClassSetBtn: TSpeedButton;
    CloseBtn: TBitBtn;
    Bevel1: TBevel;
    CancelBtn: TSpeedButton;
    DataSource1: TDataSource;
    RenTable: TTable;
    RenDatabase: TDatabase;
    RenSessionDB: TSession;
    FieldComboBox: TComboBox;
    LayerComboBox: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    ValueListBox: TListBox;
    Label3: TLabel;
    Label4: TLabel;
    ClassesCB: TComboBox;
    Label5: TLabel;
    ClassCBBegin: TComboBox;
    ClassCBEnd: TComboBox;
    ClassStartPanel: TPanel;
    ClassFinishPanel: TPanel;
    UniqueRG: TRadioGroup;
    Label6: TLabel;
    ClassifyPB: TProgressBar;
    StatsRG: TRadioGroup;
    procedure CancelBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure ValueSetBtnClick(Sender: TObject);
(*    function GetLayerIndex({lyrCollection: variant; }layerName:
      string): longint;*)
    procedure Applyit;
    procedure LayerComboBoxChange(Sender: TObject);
{    procedure LayerComboUpdate(index: Integer);}
    procedure FieldsComboUpdate(DoRenderCurrentLayer:Integer);
    procedure FieldComboBoxChange(Sender: TObject);
    procedure ClassSetBtnClick(Sender: TObject);
    procedure ClassesCBChange(Sender: TObject);
    procedure ClassStartPanelClick(Sender: TObject);
    procedure ClassFinishPanelClick(Sender: TObject);
  private

  public
    procedure Init;
  end;

var
  renderfrm: TRenderFrm;
  CancelSet, ValuesSet, ClassesSet, FirstTime: Boolean;
  RenderCurrentLayer,{selected from LayerComboBox or LayerCount when loaded}
  RenderCurrentObj, {selected when searching else 0}
  RenderCurrentField {selected from FieldComboBox}
  :Integer;
  ClassColorArray:Array of TColor;
implementation

uses  LoGlobals, LoeditFrm, AllShapeLoaderFrm;

{$R *.DFM}

procedure TRenderFrm.FormCreate(Sender: TObject);
begin
  top := renderedfrmY;
  left := renderedfrmX;
  FirstTime := True;
  Setlength(ClassColorArray,12);
  ApplyBtn.Enabled:=False;
end;

procedure TRenderFrm.CloseBtnClick(Sender: TObject);
begin
{  Applyit;}
  RenderFrm.close;
end;

procedure TRenderFrm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  VoEditForm.LayerComboBox.ItemIndex:= LayerComboBox.ItemIndex;
  VoEditForm.LayerComboBoxChange(Sender);

  renderedfrmY := RenderFrm.top;
  renderedfrmX := RenderFrm.left;
  Setlength(ClassColorArray,0);
  FirstTime:=True;
end;

procedure TRenderFrm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(9000);
end;

procedure TRenderFrm.CancelBtnClick(Sender: TObject);
begin
    ValuesSet := False;
    CancelSet := True;
    ClassesSet := False;
  ApplyBtn.Enabled:=False;    
end;


procedure TRenderFrm.FieldsComboUpdate(DoRenderCurrentLayer:Integer);
var
  i: integer;
begin
  FieldComboBox.Items.Clear;
  RenderCurrentLayer:=DoRenderCurrentLayer;
  for i := 0 to LayA[RenderCurrentLayer].AttributesN-1  do
  begin
    FieldComboBox.Items.Add(LayA[RenderCurrentLayer].AttType[i].Displayname);
  end;
  FieldComboBox.ItemIndex := 0;
        ValuesSet := False;
        CancelSet := False;
        ClassesSet := False;
end;

procedure TRenderFrm.LayerComboBoxChange(Sender: TObject);
begin
  FieldsComboUpdate(LayerComboBox.ItemIndex+1);
  RenderFrm.Init;
end;


procedure TRenderFrm.FieldComboBoxChange(Sender: TObject);
begin
  RenderFrm.Init;
end;

procedure TRenderFrm.Init;
var
i:Integer;
Datum:String;
begin
  If FirstTime then
  begin
  RenderCurrentLayer:=CurrentLayer;
  RenderCurrentObj:=CurrentObj;
  RenderCurrentField:=CurrentField;
  LayerComboBox.Items.Clear;
  for i := 0 to LayersLoaded - 1 do
  begin
    LayerComboBox.Items.Add(LayA[i+1].Filename);
  end;
  LayerComboBox.ItemIndex:=RenderCurrentLayer-1;
  FieldsComboUpdate(LayerComboBox.ItemIndex+1);
  end;
  ApplyBtn.Enabled:=False;
  ValuesSet := False;
  ClassesSet:= False;
  CancelSet := False;
  FirstTime:=False;
  RenderCurrentLayer :=LayerComboBox.ItemIndex+1;
   {LayerComboBox.Items[LayerComboBox.ItemIndex]; }
  RenderCurrentField :=FieldComboBox.ItemIndex;
   {FieldComboBox.Items[FieldComboBox.ItemIndex];}
If (  (LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftSmallint)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftInteger)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftWord)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftLargeint))
then  Datum:= 'Integer'
else
If ((LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftFloat)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftCurrency)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftDateTime))
then  Datum:= 'Float'
else Datum:= 'String';
  caption := 'Classify the '
  + FieldComboBox.Items[FieldComboBox.ItemIndex]+' '
  + Datum
  + ' attributes of '
  + LayerComboBox.Items[LayerComboBox.ItemIndex];
  ValueListBox.Items.Clear;
  ClassListBox2.Items.Clear;
end;


procedure TRenderFrm.ApplyBtnClick(Sender: TObject);
begin
  Applyit;
end;

procedure TRenderFrm.Applyit;

begin
  if ((ClassesSet) and (not CancelSet)) then
  begin
    MapA[RenderCurrentLayer].SymLayerSymboled:=3;
      VoEditForm.DVDORedraw;
  end else
  if ((ValuesSet) and (not CancelSet)) then
  begin
    MapA[RenderCurrentLayer].SymLayerSymboled:=2;
      VoEditForm.DVDORedraw;
  end else if (CancelSet) then
  begin
    MapA[RenderCurrentLayer].SymLayerSymboled:=1;
      VoEditForm.DVDORedraw;
  end;
end;


procedure TRenderFrm.ValueSetBtnClick(Sender: TObject);
var
 ShapeisType, Selected,TooMany,Switch,ishape,i,i0: Integer;
 ValueString,DataString: string;
begin
  if ((not ValuesSet)) then
  begin
  ClassifyPB.Position:=0;
  ClassifyPB.Visible:=True;
  Switch:=UniqueRG.ItemIndex;
  TooMany:=0;
    ShapeisType:= LayA[RenderCurrentLayer].ShpType;
    {prevent repaints until done }
    ValueListBox.Items.BeginUpdate;
    { empty the list of any old values }
    ValueListBox.Items.Clear;
    {Set list of fields from database}
{        fieldNames := lyr.Fields;}
    ListBox1.Items.BeginUpdate;
    ListBox1.Items.Clear;
    ishape:= LayA[RenderCurrentLayer].ShapeN;
    For I:= 0 to LayA[RenderCurrentLayer].ShapeN-1 do
    begin
      ListBox1.Items.Add(LayA[RenderCurrentLayer].LyrShp[I+1].AAttributes[RenderCurrentField]);
      ClassifyPB.Position:= Round((I / ishape) * 100);
      Application.ProcessMessages;
    end;
    ListBox1.Sorted := True;
      { make sure the fields are sorted }
    DataString := ListBox1.Items.Strings[0];
    ValueListBox.Items.Add(ListBox1.Items.Strings[0]);
     { Showmessage(DataString);    }
     ishape:=ListBox1.Items.Count;
    for i := 1 to (ListBox1.Items.Count - 1) do
    begin
      ClassifyPB.Position:= Round((I / ishape) * 100);
       Application.ProcessMessages;
      {Fill list2 with items  That are NOT Duplicates..from a Sorted List}
      if (DataString <> ListBox1.Items.Strings[i]) then
      begin
      inc(TooMany);
        DataString := ListBox1.Items.Strings[i];
        ValueListBox.Items.Add(ListBox1.Items.Strings[i]);
      end; {IF}
    end; {for}
    ListBox1.Items.Clear; {Done so empty it}
    {reenable painting }
    {Items.EndUpdate;}
    ValueListBox.Items.EndUpdate;
    {Send ValueListBox to the rendereder... in Apply}
    If TooMany> 100 then Showmessage('last one is '+Inttostr(TooMany));

{List updated.. do Classification}
    ValuesSet := True;
    CancelSet := False;
    ClassesSet := False;
    ishape:= LayA[RenderCurrentLayer].ShapeN;
    For I:= 1 to LayA[RenderCurrentLayer].ShapeN do
    begin
      ClassifyPB.Position:= Round((I / ishape) * 100);
      Application.ProcessMessages;
      DataString :=LayA[RenderCurrentLayer].LyrShp[I].AAttributes[RenderCurrentField];
    for i0 := 0 to (ValueListBox.Items.Count - 1) do
    begin
      ValueString := ValueListBox.Items.Strings[i0];
      If (DataString=ValueString)then
      begin
         Selected:=i0;
         If Switch = 0 then{Rotate Symbol}
         begin
         If ((ShapeisType =0)or(ShapeisType =8)) then
         begin
         MapA[RenderCurrentLayer].LyrSym[I].SymStyle:=(Selected mod 5)-1
         end else
         If ShapeisType =3 then
         begin
           MapA[RenderCurrentLayer].LyrSym[I].SymLineStyle:=(Selected mod 4)-1;
         end else
         If ShapeisType =5 then
         begin
         MapA[RenderCurrentLayer].LyrSym[I].SymStyle:=(Selected mod 7)-1
         end;
         end else
         If Switch = 1 then{Rotate Colors}
         begin
       MapA[RenderCurrentLayer].LyrSym[I].SymLineColor:=
       ShapeLoaderForm.SetMyColor(Selected) ;
       MapA[RenderCurrentLayer].LyrSym[I].SymBrushColor
        :=ShapeLoaderForm.SetMyColor(Selected);
         end else
         If Switch = 2 then{Rotate both}
         begin
       MapA[RenderCurrentLayer].LyrSym[I].SymLineColor:=
       ShapeLoaderForm.SetMyColor(Selected) ;
       MapA[RenderCurrentLayer].LyrSym[I].SymBrushColor
        :=ShapeLoaderForm.SetMyColor(Selected);
         If ((ShapeisType =0)or(ShapeisType =8)) then
         begin
         MapA[RenderCurrentLayer].LyrSym[I].SymStyle:=(Selected mod 5)-1
         end else
         If ShapeisType =3 then
         begin
           MapA[RenderCurrentLayer].LyrSym[I].SymLineStyle:=(Selected mod 4)-1;
         end else
         If ShapeisType =5 then
         begin
         MapA[RenderCurrentLayer].LyrSym[I].SymStyle:=(Selected mod 7)-1
         end;
         end;

      Break;{exit a for, while, or repeat statement }
      end;{(DataString=ValueString)}
      end;{for i0}
    end;{for i}
  ApplyBtn.Enabled:=True;    
  end; {if not set begin}
  ClassifyPB.Position:=0;
  ClassifyPB.Visible:=False;
end; {Procedure}

    {Set list of fields from database}
     {   fieldNames := lyr.Fields;
        RenderFrm.ListBox1.Items.BeginUpdate;
        RenderFrm.ListBox1.Items.Clear;
        for i := 0 to fieldNames.Count -1 do begin
          strItem := fieldNames.Item[i];
          strItem2 := IDValues.Item[i];
          strItemS:= VarToStr(strItem);
          strItem2S:= VarToStr(strItem2);
          If (strItemS=fieldName) then
           RenderFrm.ListBox1.Items.Add(strItem2S);
         end;
         RenderFrm.ListBox1.Sorted := True; }
    // Remember layer contruction and delete it.
{fLayerHolder := TLayerPropInfo.Create(lyr);
lyrs.Remove(fLayerIndex);}
{    RenderFrm.LayerComboUpdate(0);}
      //Add to combo box containing layers
(***********************************************************)

procedure TRenderFrm.ClassSetBtnClick(Sender: TObject);
var
 Selected,ShapeisType,Switch, ishape,i,iToo: Integer;
 Breaks,Difference,Datum,Maxima, Minima:Double;
 DataString: string;
begin
  if ((not ClassesSet)) then
  begin
    ClassifyPB.Position:=0;
    ClassifyPB.Visible:=True;
If ( (LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftSmallint)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftInteger)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftWord)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftLargeint)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftFloat)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftCurrency)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftDateTime))
    then
    begin

ClassesCBChange(Sender);
      Switch:=UniqueRG.ItemIndex;
      ShapeisType:= LayA[RenderCurrentLayer].ShpType;
Case ClassesCB.ItemIndex of
0:Mapa[CurrentLayer].SymLayerClasses:=5;
1:Mapa[CurrentLayer].SymLayerClasses:=7;
2:Mapa[CurrentLayer].SymLayerClasses:=9;
3:Mapa[CurrentLayer].SymLayerClasses:=11;
end;{case}
 Setlength(Mapa[CurrentLayer].SymLayerClassBreaks,
           Mapa[CurrentLayer].SymLayerClasses+1);
 Maxima:=-4.9E324;{0;}{(-4.9 * power(10,324));}
 Minima:=1.6E308;{0;}{(1.6 * power(10,308));}
    ishape:= LayA[RenderCurrentLayer].ShapeN;
    For I:= 1 to LayA[RenderCurrentLayer].ShapeN do
    begin
      ClassifyPB.Position:= Round((I / ishape) * 100);
      Application.ProcessMessages;
      DataString :=LayA[RenderCurrentLayer].LyrShp[I].AAttributes[RenderCurrentField];
If (  (LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftSmallint)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftInteger)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftWord)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftLargeint))
then  Datum:= StrToInt(DataString)
else
If ((LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftFloat)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftCurrency)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftDateTime))
then  Datum:= StrToFloat(DataString)
else Datum:=0;
 If Datum >Maxima then Maxima:=Datum;
 If Datum <Minima then Minima:=Datum;
    end;
    Difference:= Maxima- Minima;
Breaks:=Difference/Mapa[CurrentLayer].SymLayerClasses;
  ClassListBox2.Clear;
For I:= 1 to Mapa[CurrentLayer].SymLayerClasses do
begin
  Mapa[CurrentLayer].SymLayerClassBreaks[I]:= (I* Breaks);
  ClassListBox2.Items.Add(
  Floattostr(Mapa[CurrentLayer].SymLayerClassBreaks[I]));
end;
{SET THE VALUES INTO Symbol}
    For I:= 1 to LayA[RenderCurrentLayer].ShapeN do
    begin
      ClassifyPB.Position:= Round((I / ishape) * 100);
      Application.ProcessMessages;
      DataString :=LayA[RenderCurrentLayer].LyrShp[I].AAttributes[RenderCurrentField];
If (  (LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftSmallint)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftInteger)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftWord)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftLargeint))
then  Datum:= StrToInt(DataString)
else
If ((LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftFloat)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftCurrency)
or(LayA[RenderCurrentLayer].AttType[RenderCurrentField].DataType=ftDateTime))
then  Datum:= StrToFloat(DataString)
else Datum:=0;
For iToo:= 1 to Mapa[CurrentLayer].SymLayerClasses do
Begin
If (Datum-Minima) <= Mapa[CurrentLayer].SymLayerClassBreaks[iToo]then
begin
  { Mapa[CurrentLayer].SymLayerBeginSize:=5;
    Mapa[CurrentLayer].SymLayerEndSize:=25;
    Mapa[CurrentLayer].SymLayerClasses:=5;
    Mapa[CurrentLayer].SymLayerStartColor:=clLime;
    Mapa[CurrentLayer].SymLayerFinishColor:=clGreen;
    SymClassSize}
         Selected:=iToo;
         If Switch = 0 then{Rotate Symbol}
         begin
         If ((ShapeisType =0)or(ShapeisType =8)) then
         begin
         MapA[RenderCurrentLayer].LyrSym[I].SymStyle:=(Selected mod 5)-1
         end else
         If ShapeisType =3 then
         begin
           MapA[RenderCurrentLayer].LyrSym[I].SymLineStyle:=(Selected mod 4)-1;
         end else
         If ShapeisType =5 then
         begin
         MapA[RenderCurrentLayer].LyrSym[I].SymStyle:=(Selected mod 6)-1
         end;
         end else
         If Switch = 1 then{Rotate Colors}
         begin
       MapA[RenderCurrentLayer].LyrSym[I].SymLineColor:=
       ClassColorArray[Selected];
       {VoEditForm.SetMyColor(Selected) ;}
       MapA[RenderCurrentLayer].LyrSym[I].SymBrushColor:=
       ClassColorArray[Selected];
        {VoEditForm.SetMyColor(Selected);}
         end else
         If Switch = 2 then{Rotate both}
         begin
       MapA[RenderCurrentLayer].LyrSym[I].SymLineColor:=
       ClassColorArray[Selected];
       {VoEditForm.SetMyColor(Selected) ;}
       MapA[RenderCurrentLayer].LyrSym[I].SymBrushColor:=
       ClassColorArray[Selected];
        {VoEditForm.SetMyColor(Selected);}
         If ((ShapeisType =0)or(ShapeisType =8)) then
         begin
         MapA[RenderCurrentLayer].LyrSym[I].SymStyle:=(Selected mod 5)-1
         end else
         If ShapeisType =3 then
         begin
           MapA[RenderCurrentLayer].LyrSym[I].SymLineStyle:=(Selected mod 4)-1;
         end else
         If ShapeisType =5 then
         begin
         MapA[RenderCurrentLayer].LyrSym[I].SymStyle:=(Selected mod 7)-1
         end;
         end;
  { Mapa[CurrentLayer].SymLayerBeginSize:=5;
    Mapa[CurrentLayer].SymLayerEndSize:=25;
    Mapa[CurrentLayer].SymLayerClasses:=5;
    Mapa[CurrentLayer].SymLayerStartColor:=clLime;
    Mapa[CurrentLayer].SymLayerFinishColor:=clGreen; }
break;    {Found so do next}
end;
End;
    end;
    ValuesSet := False;
    CancelSet := False;
    ClassesSet := True;
    ApplyBtn.Enabled:=True;      
    end else Showmessage('Not a Numeric Field');
  end; {if not set begin}
  ClassifyPB.Position:=0;
  ClassifyPB.Visible:=False;
end;


procedure TRenderFrm.ClassesCBChange(Sender: TObject);
var i,toSet:Integer;
GetRa,GetGa,GetBa,
GetR,GetG,GetB:Byte;
begin
Case ClassesCB.ItemIndex of
0:toSet:=5;
1:toSet:=7;
2:toSet:=9;
3:toSet:=11;
else toSet:=11;
end;{case}
  Setlength(ClassColorArray,toSet+1);
{ClassStartPanel.Color:=VoEditForm.SetMyColor(1);
ClassFinishPanel.Color:=VoEditForm.SetMyColor(toSet);}
ClassColorArray[1]:=ClassStartPanelColor;
GetR:=GetRValue(ClassStartPanelColor);
GetG:=GetGValue(ClassStartPanelColor);
GetB:=GetBValue(ClassStartPanelColor);
GetRa:=((255-GetR)div toSet);
GetGa:=((255-GetG)div toSet);
GetBa:=((255-GetB)div toSet);
for i := 2 to toSet do
begin
ClassColorArray[i] :=
  RGB(
  GetR - (i * GetRa),
  GetG - (i * GetGa),
  GetB - (i * GetBa));
end;
ClassStartPanel.Color:=ClassColorArray[1];
ClassFinishPanel.Color:=ClassColorArray[toSet];
ClassesSet:=False;
  ApplyBtn.Enabled:=False;
  ClassListBox2.Clear;
end;
(***********************************************************)

procedure TRenderFrm.ClassStartPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:=ClassStartPanelColor;
  if ColorDialog1.Execute then
  begin
    ClassStartPanelColor  := ColorDialog1.Color;
    ClassStartPanel.Color := ColorDialog1.Color;
    ClassesCBChange(Sender);
  end;
end;

procedure TRenderFrm.ClassFinishPanelClick(Sender: TObject);
var i,toSet:Integer;
GetRa,GetGa,GetBa,
GetR,GetG,GetB:Byte;
begin
Case ClassesCB.ItemIndex of
0:toSet:=5;
1:toSet:=7;
2:toSet:=9;
3:toSet:=11;
else toSet:=11;
end;{case}
  Setlength(ClassColorArray,toSet+1);
{ClassStartPanel.Color:=VoEditForm.SetMyColor(1);
ClassFinishPanel.Color:=VoEditForm.SetMyColor(toSet);}
ClassStartPanelColor:=ClassFinishPanel.Color;
ClassColorArray[1]:=ClassStartPanelColor;
GetR:=GetRValue(ClassStartPanelColor);
GetG:=GetGValue(ClassStartPanelColor);
GetB:=GetBValue(ClassStartPanelColor);
GetRa:=((255-GetR)div toSet);
GetGa:=((255-GetG)div toSet);
GetBa:=((255-GetB)div toSet);

for i := 0 to toSet do
begin
ClassColorArray[i] :=
  RGB(
  0+ (i * GetRa),
  0+ (i * GetGa),
  0+ (i * GetBa));
end;
ClassStartPanel.Color:=ClassColorArray[1];
ClassFinishPanel.Color:=ClassColorArray[toSet];
ClassesSet:=False;
  ApplyBtn.Enabled:=False;
  ClassListBox2.Clear;
end;




end.
